"""
    KantorovichTypeController

Default controller for implicit discrete solvers. Assuming a Newton method is used
to solve the nonlinear problem, this controller uses convergence rate estimates to
adapt the step size based on an posteriori estimate of the change in the Newton
convergence radius between steps as described below.

Given the convergence rate estimate Θ₀ for the first iteration, the step size controller 
adapts the time step as `dtₙ₊₁ = γ * (g(Θbar) / (g(Θ₀)))^(1 / p) dtₙ`
with `g(x) = √(1 + 4x) - 1`. `p` denotes the order of the solver -- i.e. the order of
the extrapolation algorithm to compute the initial guess for the solve at `tₙ` given a 
solution at `tₙ₋₁` -- and `Θbar` denotes the  target convergence rate. `γ` is a safety factor.

A factor `Θreject` controls the rejection of a time step if any `Θₖ > Θreject`.
In this case the first Θₖ violating this criterion is taken and the time step is adapted
such that `dtₙ₊₁ = γ * (g(Θbar) / (g(Θk)))^(1 / p) dtₙ`. This behavior can be changed
by setting `strict = false`. In this case the step is accepted whenever the Newton
solver converges.

The controller furthermore limits the growth and shrinkage of the time step by a factor
between `qmin` and `qmax`.

The baseline algorithm has been derived in Peter Deuflhard's book "Newton Methods for
Nonlinear Problems" in Section 5.1.3 (Adaptive pathfollowing algorithms). Please note
that some implementation details deviate from the original algorithm.
"""
Base.@kwdef struct KantorovichTypeController{T} <: AbstractController
    Θmin::T
    p::Int64
    Θreject::T = 0.95
    Θbar::T = 0.5
    γ::T = 0.95
    qmin::T = 1 / 5
    qmax::T = 5.0
    strict::Bool = true
end

@static if Base.pkgversion(OrdinaryDiffEqCore) >= v"3.4"
    @eval begin
        mutable struct KantorovichTypeControllerCache{T} <: AbstractControllerCache
            controller::KantorovichTypeController{T}
            # Proposed scaling factor for the time step length
            q::T
        end

        function OrdinaryDiffEqCore.default_controller_v7(
                QT, alg::IDSolve,
            )
            return KantorovichTypeController{QT}(; Θmin = QT(1 // 8), p = 1)
        end

        function OrdinaryDiffEqCore.setup_controller_cache(alg, atmp, controller::KantorovichTypeController{T}) where {T}
            return KantorovichTypeControllerCache(
                controller,
                T(1),
            )
        end

        function OrdinaryDiffEqCore.stepsize_controller!(
                integrator, cache::KantorovichTypeControllerCache, alg::IDSolve
            )
            (; controller) = cache
            @inline g(x) = √(1 + 4x) - 1

            # Adapt dt with a priori estimate (Eq. 5.24)
            (; Θks) = integrator.cache
            (; Θbar, γ, Θmin, qmin, qmax, p) = controller

            Θ₀ = length(Θks) > 0 ? max(first(Θks), Θmin) : Θmin
            cache.q = clamp(γ * (g(Θbar) / (g(Θ₀)))^(1 / p), qmin, qmax)

            return cache.q
        end

        function OrdinaryDiffEqCore.step_accept_controller!(
                integrator, cache::KantorovichTypeControllerCache, alg::IDSolve, q
            )
            @assert q ≈ cache.q "Controller cache went out of sync with time stepping logic."
            return cache.q * integrator.dt
        end

        function OrdinaryDiffEqCore.step_reject_controller!(
                integrator, cache::KantorovichTypeControllerCache, alg::IDSolve
            )
            (; controller) = cache
            @inline g(x) = √(1 + 4x) - 1

            # Shorten dt according to (Eq. 5.24)
            (; Θks) = integrator.cache
            (; Θbar, Θreject, γ, Θmin, qmin, qmax, p) = controller
            for Θk in Θks
                if Θk > Θreject
                    q = clamp(γ * (g(Θbar) / g(Θk))^(1 / p), qmin, qmax)
                    integrator.dt = q * integrator.dt
                    return
                end
            end
            return
        end

        function OrdinaryDiffEqCore.accept_step_controller(integrator, cache::KantorovichTypeControllerCache)
            (; controller) = cache
            (; Θks) = integrator.cache
            if controller.strict
                return all(controller.Θreject .< Θks)
            else
                return true
            end
        end
    end
else
    @eval begin
        function OrdinaryDiffEqCore.default_controller(
                alg::IDSolve, cache::IDSolveCache, _1, _2, _3
            )
            return KantorovichTypeController(; Θmin = float(1 // 8), p = 1)
        end

        function OrdinaryDiffEqCore.stepsize_controller!(
                integrator, controller::KantorovichTypeController, alg::IDSolve
            )
            @inline g(x) = √(1 + 4x) - 1

            # Adapt dt with a priori estimate (Eq. 5.24)
            (; Θks) = integrator.cache
            (; Θbar, γ, Θmin, qmin, qmax, p) = controller

            Θ₀ = length(Θks) > 0 ? max(first(Θks), Θmin) : Θmin
            q = clamp(γ * (g(Θbar) / (g(Θ₀)))^(1 / p), qmin, qmax)

            return q
        end

        function OrdinaryDiffEqCore.step_accept_controller!(
                integrator, controller::KantorovichTypeController, alg::IDSolve, q
            )
            return q * integrator.dt
        end

        function OrdinaryDiffEqCore.step_reject_controller!(
                integrator, controller::KantorovichTypeController, alg::IDSolve
            )
            @inline g(x) = √(1 + 4x) - 1

            # Shorten dt according to (Eq. 5.24)
            (; Θks) = integrator.cache
            (; Θbar, Θreject, γ, Θmin, qmin, qmax, p) = controller
            for Θk in Θks
                if Θk > Θreject
                    q = clamp(γ * (g(Θbar) / g(Θk))^(1 / p), qmin, qmax)
                    integrator.dt = q * integrator.dt
                    return
                end
            end
            return
        end

        function OrdinaryDiffEqCore.accept_step_controller(integrator, controller::KantorovichTypeController)
            (; Θks) = integrator.cache
            if controller.strict
                return all(controller.Θreject .< Θks)
            else
                return true
            end
        end
    end
end

module ImplicitDiscreteSolve

using SciMLBase
using NonlinearSolveBase
using NonlinearSolveFirstOrder
using SymbolicIndexingInterface: parameter_symbols
import OrdinaryDiffEqCore: OrdinaryDiffEqAlgorithm, alg_cache, OrdinaryDiffEqMutableCache,
    OrdinaryDiffEqConstantCache, get_fsalfirstlast, isfsal,
    initialize!, perform_step!, isdiscretecache, isdiscretealg,
    alg_order, beta2_default, beta1_default, dt_required,
    _initialize_dae!, DefaultInit, BrownFullBasicInit, OverrideInit,
    @muladd, @.., _unwrap_val, OrdinaryDiffEqCore, isadaptive,
    AbstractController, allows_null_u0

@static if Base.pkgversion(OrdinaryDiffEqCore) >= v"3.4"
    @eval begin
        import OrdinaryDiffEqCore: AbstractControllerCache
    end
end

using Reexport
@reexport using SciMLBase

include("algorithms.jl")
include("cache.jl")
include("solve.jl")
include("alg_utils.jl")
include("controller.jl")

export IDSolve

end

struct ImplicitDiscreteState{uType, pType, tType}
    u::uType
    p::pType
    t::tType
end

mutable struct IDSolveCache{uType, cType, thetaType} <: OrdinaryDiffEqMutableCache
    u::uType
    uprev::uType
    z::uType
    nlcache::cType
    Θks::thetaType
end

# u === nothing path: no state to evolve (e.g. MTK systems with only callbacks).
# Bypass NonlinearSolve entirely — there is nothing to nonlinear-solve, and
# constructing a NonlinearProblem with empty u would force the nonlinear
# solver to handle a degenerate case. Returning a cache with `nlcache=nothing`
# is dispatched on in `perform_step!` below to make stepping a no-op success.
function alg_cache(
        alg::IDSolve, ::Nothing, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return IDSolveCache(nothing, nothing, nothing, nothing, uBottomEltypeNoUnits[])
end
function alg_cache(
        alg::IDSolve, ::Nothing, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return IDSolveCache(nothing, nothing, nothing, nothing, uBottomEltypeNoUnits[])
end

function alg_cache(
        alg::IDSolve, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    state = ImplicitDiscreteState(zero(u), p, t)
    f_nl = (resid, u_next, p) -> f(resid, u_next, p.u, p.p, p.t)

    nlls = !isnothing(f.resid_prototype) && (length(f.resid_prototype) != length(u))
    prob = if nlls
        NonlinearLeastSquaresProblem{isinplace(f)}(
            NonlinearFunction(f_nl; resid_prototype = f.resid_prototype),
            u, state
        )
    else
        NonlinearProblem{isinplace(f)}(f_nl, u, state)
    end

    nlcache = init(prob, alg.nlsolve)

    return IDSolveCache(u, uprev, state.u, nlcache, uBottomEltypeNoUnits[])
end

isdiscretecache(cache::IDSolveCache) = true

function alg_cache(
        alg::IDSolve, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    state = ImplicitDiscreteState(zero(u), p, t)
    f_nl = (u_next, p) -> f(u_next, p.u, p.p, p.t)

    nlls = !isnothing(f.resid_prototype) && (length(f.resid_prototype) != length(u))
    prob = if nlls
        NonlinearLeastSquaresProblem{isinplace(f)}(
            NonlinearFunction(f_nl; resid_prototype = f.resid_prototype),
            u, state
        )
    else
        NonlinearProblem{isinplace(f)}(f_nl, u, state)
    end

    nlcache = init(prob, alg.nlsolve)

    # FIXME Use IDSolveConstantCache?
    return IDSolveCache(u, uprev, state.u, nlcache, uBottomEltypeNoUnits[])
end

get_fsalfirstlast(cache::IDSolveCache, rate_prototype) = (nothing, nothing)

#runtests
using Test
using ImplicitDiscreteSolve
using OrdinaryDiffEqCore
using OrdinaryDiffEqSDIRK
using SciMLBase
using SafeTestsets
using Pkg

const TEST_GROUP = get(ENV, "ODEDIFFEQ_TEST_GROUP", "ALL")

function activate_qa_env()
    Pkg.activate(joinpath(@__DIR__, "qa"))
    return Pkg.instantiate()
end

# Run functional tests
if TEST_GROUP != "QA"
    # Test implicit Euler using ImplicitDiscreteProblem
    @testset "Implicit Euler" begin
        function lotkavolterra(u, p, t)
            [1.5 * u[1] - u[1] * u[2], -3.0 * u[2] + u[1] * u[2]]
        end

        function f!(resid, u_next, u, p, t)
            lv = lotkavolterra(u_next, p, t)
            resid[1] = u_next[1] - u[1] - 0.01 * lv[1]
            resid[2] = u_next[2] - u[2] - 0.01 * lv[2]
            nothing
        end
        u0 = [1.0, 1.0]
        tspan = (0.0, 0.5)

        idprob = ImplicitDiscreteProblem(f!, u0, tspan, []; dt = 0.01)
        idsol = solve(idprob, IDSolve(); adaptive = false)

        oprob = ODEProblem(lotkavolterra, u0, tspan)
        osol = solve(oprob, ImplicitEuler())

        @test isapprox(idsol.u[end], osol.u[end], atol = 0.1)

        ### free-fall
        # y, dy
        function ff(u, p, t)
            [u[2], -9.8]
        end

        function g!(resid, u_next, u, p, t)
            f = ff(u_next, p, t)
            resid[1] = u_next[1] - u[1] - 0.01 * f[1]
            resid[2] = u_next[2] - u[2] - 0.01 * f[2]
            nothing
        end
        u0 = [10.0, 0.0]
        tspan = (0, 0.2)

        idprob = ImplicitDiscreteProblem(g!, u0, tspan, []; dt = 0.01)
        idsol = solve(idprob, IDSolve(); adaptive = false)

        oprob = ODEProblem(ff, u0, tspan)
        osol = solve(oprob, ImplicitEuler())

        @test isapprox(idsol.u[end], osol.u[end], atol = 0.1)
    end

    @testset "Solver initializes" begin
        function periodic!(resid, u_next, u, p, t)
            resid[1] = u_next[1] - u[1] - sin(t * π / 4)
            resid[2] = 16 - u_next[2]^2 - u_next[1]^2
        end

        tsteps = 15
        u0 = [1.0, 3.0]
        idprob = ImplicitDiscreteProblem(periodic!, u0, (0, tsteps), [])
        integ = init(idprob, IDSolve())
        @test integ.u[1]^2 + integ.u[2]^2 ≈ 16

        for ts in 1:tsteps
            step!(integ)
            @test integ.u[1]^2 + integ.u[2]^2 ≈ 16
        end
    end

    @testset "Hard problem" begin
        function hard!(resid, u, u_prev, p, t)
            resid[1] = tanh((u[1] - 10t)^2) / 2
        end

        u0 = [0.0]
        idprob = ImplicitDiscreteProblem(hard!, u0, (0.0, 1.0), [])
        integrator = init(idprob, IDSolve())
        idsol = solve!(integrator)
        @test idsol.retcode == ReturnCode.Success
    end

    @testset "Handle nothing in u0" begin
        emptyiip(residual, u_next, u, p, t) = nothing
        emptyoop(u_next, u, p, t) = nothing

        tsteps = 5
        u0 = nothing

        idprob = ImplicitDiscreteProblem(emptyiip, u0, (0, tsteps), [])
        sol = solve(idprob, IDSolve())
        @test sol.retcode == ReturnCode.Success

        idprob2 = ImplicitDiscreteProblem(emptyoop, u0, (0, tsteps), [])
        sol2 = solve(idprob2, IDSolve())
        @test sol2.retcode == ReturnCode.Success
    end

    @testset "Create NonlinearLeastSquaresProblem" begin
        function over(u_next, u, p, t)
            [u_next[1] - 1, u_next[2] - 1, u_next[1] - u_next[2]]
        end

        tsteps = 5
        u0 = [1.0, 1.0]
        idprob = ImplicitDiscreteProblem(
            ImplicitDiscreteFunction(over, resid_prototype = zeros(3)), u0, (0, tsteps), []
        )
        integ = init(idprob, IDSolve())
        @test integ.cache.nlcache.prob isa NonlinearLeastSquaresProblem

        function under(u_next, u, p, t)
            [u_next[1] - u_next[2] - 1]
        end
        idprob = ImplicitDiscreteProblem(
            ImplicitDiscreteFunction(under; resid_prototype = zeros(1)), u0, (0, tsteps), []
        )
        integ = init(idprob, IDSolve())
        @test integ.cache.nlcache.prob isa NonlinearLeastSquaresProblem

        function full(u_next, u, p, t)
            [u_next[1]^2 - 3, u_next[2] - u[1]]
        end
        idprob = ImplicitDiscreteProblem(
            ImplicitDiscreteFunction(full; resid_prototype = zeros(2)), u0, (0, tsteps), []
        )
        integ = init(idprob, IDSolve())
        @test integ.cache.nlcache.prob isa NonlinearProblem
    end

    @testset "Null u0 bypasses NonlinearSolve" begin
        # IDSolve overrides allows_null_u0 so `nothing` reaches alg_cache unchanged
        # and the `::Nothing` dispatch returns a cache with nlcache=nothing. Without
        # the opt-in, u0 is coerced to Float64[] and NonlinearSolve fails building
        # a 0x1 Jacobian for the least-squares branch.
        fn = ImplicitDiscreteFunction(; resid_prototype = [0.0]) do du, unext, u, p, t
            du[1] = 1
        end
        pr = ImplicitDiscreteProblem(fn, nothing, (0, 1))
        integ = init(pr, IDSolve())
        @test integ.cache.u === nothing
        @test integ.cache.nlcache === nothing
        sol = solve(pr, IDSolve())
        @test SciMLBase.successful_retcode(sol)
    end

    @testset "InitialFailure thrown" begin
        function bad(u_next, u, p, t)
            [u_next[1] - u_next[2], u_next[1] - 3, u_next[2] - 4]
        end

        u0 = [3.0, 4.0]
        idprob = ImplicitDiscreteProblem(bad, u0, (0, 0), [])
        integ = init(idprob, IDSolve())
        @test check_error(integ) == ReturnCode.InitialFailure
        sol = solve(idprob, IDSolve())
        @test length(sol.u) == 1
        @test !SciMLBase.successful_retcode(sol)
    end
end

# Run QA tests (JET, Aqua)
if TEST_GROUP != "Core" && isempty(VERSION.prerelease)
    activate_qa_env()
    @time @safetestset "JET Tests" include("qa/jet.jl")
    @time @safetestset "Aqua" include("qa/qa.jl")
end

# u === nothing path: nothing to step. The integrator's state is unchanged
# and the step trivially succeeds.
function perform_step!(
        integrator, cache::IDSolveCache{Nothing, Nothing}, repeat_step = false
    )
    return nothing
end

function perform_step!(integrator, cache::IDSolveCache, repeat_step = false)
    (; alg, u, uprev, dt, t, tprev, f, p) = integrator
    (; nlcache, Θks) = cache

    # initial guess
    if alg.extrapolant == :constant
        cache.z .= integrator.u
    else
        error("Unknown extrapolant $(alg.extrapolant).")
    end
    state = ImplicitDiscreteState(cache.z, p, t + dt)

    # nonlinear solve step
    SciMLBase.reinit!(nlcache, p = state)

    # solve!(nlcache)
    # The solve here is simply unrolled by hand to query the convergence rate estimates "manually" for now
    if nlcache.retcode == ReturnCode.InitialFailure
        integrator.force_stepfail = true
        return
    end

    resize!(Θks, 0)
    residualnormprev = zero(eltype(u))
    while NonlinearSolveBase.not_terminated(nlcache)
        step!(nlcache)
        residualnorm = NonlinearSolveBase.L2_NORM(nlcache.fu)
        if nlcache.nsteps > 1
            # Θk = min(residualnorm/residualnormprev, incrementnorm/incrementnormprev)
            Θk = residualnorm / residualnormprev
            if residualnormprev ≈ 0.0 #|| incrementnormprev ≈ 0.0
                push!(Θks, 0.0)
            else
                push!(Θks, Θk)
            end
            # if nlcache.parameters.enforce_monotonic_convergence && Θk ≥ 1.0
            #     @debug "Newton-Raphson diverged. Aborting. ||r|| = $residualnorm" _group=:nlsolve
            #     return false
            # end
        end
        residualnormprev = residualnorm
    end

    # The solver might have set a different `retcode`
    if nlcache.retcode == ReturnCode.Default
        nlcache.retcode = ifelse(
            nlcache.nsteps ≥ nlcache.maxiters, ReturnCode.MaxIters, ReturnCode.Success
        )
    end

    NonlinearSolveBase.update_from_termination_cache!(nlcache.termination_cache, nlcache)

    NonlinearSolveBase.update_trace!(
        nlcache.trace, nlcache.nsteps, NonlinearSolveBase.get_u(nlcache),
        NonlinearSolveBase.get_fu(nlcache), nothing, nothing, nothing;
        last = Val(true)
    )

    if nlcache.retcode != ReturnCode.Success
        integrator.force_stepfail = true
        return
    end

    # Accept step
    return u .= nlcache.u
end

function initialize!(integrator, cache::IDSolveCache)
    return integrator.u isa AbstractVector && (cache.z .= integrator.u)
end

function _initialize_dae!(
        integrator, prob::ImplicitDiscreteProblem,
        alg::DefaultInit, x::Union{Val{true}, Val{false}}
    )
    isnothing(prob.u0) && return
    atol = one(eltype(prob.u0)) * 1.0e-12
    return if SciMLBase.has_initializeprob(prob.f)
        _initialize_dae!(
            integrator, prob,
            OverrideInit(atol), x
        )
    else
        (; u, p, t, f) = integrator
        initstate = ImplicitDiscreteState(u, p, t)

        _f = if isinplace(f)
            (resid, u_next, p) -> f(resid, u_next, p.u, p.p, p.t)
        else
            (u_next, p) -> f(u_next, p.u, p.p, p.t)
        end

        nlls = !isnothing(f.resid_prototype) &&
            (length(f.resid_prototype) != length(integrator.u))
        prob = if nlls
            NonlinearLeastSquaresProblem{isinplace(f)}(
                NonlinearFunction(_f; resid_prototype = f.resid_prototype), u, initstate
            )
        else
            NonlinearProblem{isinplace(f)}(_f, u, initstate)
        end
        sol = solve(prob, integrator.alg.nlsolve)
        if sol.retcode == ReturnCode.Success
            integrator.u = sol
        else
            integrator.sol = SciMLBase.solution_new_retcode(
                integrator.sol, ReturnCode.InitialFailure
            )
        end
    end
end

"""
    IDSolve()

First order solver for `ImplicitDiscreteSystems`.
"""
struct IDSolve{NLS} <:
    OrdinaryDiffEqAlgorithm
    nlsolve::NLS
    extrapolant::Symbol
end

function IDSolve(;
        nlsolve = NewtonRaphson(),
        extrapolant = :constant,
    )
    return IDSolve{typeof(nlsolve)}(nlsolve, extrapolant)
end

function SciMLBase.isautodifferentiable(alg::IDSolve)
    return true
end
function SciMLBase.allows_arbitrary_number_types(alg::IDSolve)
    return true
end
function SciMLBase.allowscomplex(alg::IDSolve)
    return true
end

SciMLBase.isdiscrete(alg::IDSolve) = true

isfsal(alg::IDSolve) = false
alg_order(alg::IDSolve) = 1
beta2_default(alg::IDSolve) = 0
beta1_default(alg::IDSolve, beta2) = 0

dt_required(alg::IDSolve) = false
isdiscretealg(alg::IDSolve) = true

isadaptive(alg::IDSolve) = true

# Preserve `u === nothing` through __init so alg_cache(alg, ::Nothing, ...) fires
# and we skip building a NonlinearProblem over an empty state.
allows_null_u0(alg::IDSolve) = true
